package shoppingcart.common;

import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

//̴ܥ֥å
public abstract class BaseServlet extends HttpServlet{

    //HTTP GETꥯȽ
    public final void doGet(HttpServletRequest req,
                HttpServletResponse res)
                throws ServletException, IOException{
        //perform˰
        perform(req, res);
    }

    //HTTP POSTꥯȽ
    public final void doPost(HttpServletRequest req,
                HttpServletResponse res)
                throws ServletException, IOException{
        //perform˰
        perform(req, res);
    }

    //̥ꥯȽ
    private void perform(HttpServletRequest req,
                HttpServletResponse res){
        //̥ǡ¤μ
        //getContext()᥽åɤϡBaseServletѾ
        //ݥ֥åȤΤ¹Ԥ
        Context myContext = getContext(req);
        if (myContext != null && !myContext.isError){
            //¹
            setup(req, res, myContext);
        }

        if (!myContext.isError){
            //ץꥱåμ¹
            //action()᥽åɤϡBaseServletѾ
            //ݥ֥åȤΤ¹Ԥ
            action(req, res, myContext);
        }

        //DB³λ
        if (myContext.dbAccess){
            try{
                myContext.jdbcConnection.close();
            }catch(Exception e){
                myContext.isError = true;
            }
        }

        if (!myContext.isError){
            //Υե
            //setPage()᥽åɤϡBaseServletѾ
            //ݥ֥åȤΤ¹Ԥ
            setPage(myContext);
        }else{
            //顼Υե
            //setErrorPage()᥽åɤϡBaseServletѾ
            //ݥ֥åȤΤ¹Ԥ
            setErrorPage(myContext);
        }

        //եɼ¹
        forward(req, res, myContext);
    }

    //
    private void setup(HttpServletRequest req,
                HttpServletResponse res, Context myContext){
        try{
            // ǡ١³
            if (myContext.dbAccess){
                String url = myContext.dbUrl + "?useUnicode=true"
                        + "&characterEncoding=" + myContext.dbEncode;
                Class driverClass =
                            Class.forName(myContext.driverName);
                myContext.jdbcConnection =
                            DriverManager.getConnection(
                            url,
                            myContext.dbUserName,
                            myContext.dbPassword);
                myContext.jdbcConnection.setAutoCommit(false);
            }
            //ꥯȤΥ󥳡
            req.setCharacterEncoding(myContext.uiEncode);
        }catch(Exception e){
            myContext.isError = true;
            myContext.message = e.toString();
        }
    }

    //եɽ
    private void forward(HttpServletRequest req,
                HttpServletResponse res, Context myContext){
        ServletContext cont = getServletContext();
        RequestDispatcher rd =
                    cont.getRequestDispatcher(myContext.nextPage);
        try{
            rd.forward(req, res);
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    //å
    protected void setAttribute(String key, Object obj,
                HttpServletRequest req){
        req.getSession().setAttribute(key, obj);
    }
    
    //å
    protected Object getAttribute(String key,
                HttpServletRequest req){
        return req.getSession().getAttribute(key);
    }
    
    //ꥯȥѥ᡼
    protected String getParameter(String key,
                HttpServletRequest req){
            return req.getParameter(key);
    }
    
    //̥ǡ¤μ
    protected Context getMyContext(String key,
                HttpServletRequest req){
        Context cont = (Context)getAttribute(key, req);
        if (cont == null){
            cont = new Context();
            cont.isError = true;
        }
        return cont;
    }

    //
    //ʸ󤬿ɤȽ(ξtrue֤)
    protected boolean isNumber(String str){
        try{
            Integer.parseInt(str);
        }catch(Exception e){
            return false;
        }
        return true;
    }
    //

    //ݥ᥽å
    //ʲΥ᥽åɤBaseServletѾݥ֥åȤǼ
    protected abstract Context getContext(HttpServletRequest req);

    protected abstract void action(HttpServletRequest req,
                HttpServletResponse res, Context myContext);

    protected abstract void setPage(Context myContext);

    protected abstract void setErrorPage(Context myContext);

}