package shoppingcart.common;

import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

//ʊ{T[ubg
public abstract class BaseServlet extends HttpServlet{

    //HTTP GETNGXg
    public final void doGet(HttpServletRequest req,
                HttpServletResponse res)
                throws ServletException, IOException{
        //performɈϑ
        perform(req, res);
    }

    //HTTP POSTNGXg
    public final void doPost(HttpServletRequest req,
                HttpServletResponse res)
                throws ServletException, IOException{
        //performɈϑ
        perform(req, res);
    }

    //ʃNGXg
    private void perform(HttpServletRequest req,
                HttpServletResponse res){
        //ʃf[^\̎擾
        //getContext()\bh́ABaseServletp
        //ۃT[ubgŒ`̂s
        Context myContext = getContext(req);
        if (myContext != null && !myContext.isError){
            //Oݒ菈s
            setup(req, res, myContext);
        }

        if (!myContext.isError){
            //AvP[VWbN̎s
            //action()\bh́ABaseServletp
            //ۃT[ubgŒ`̂s
            action(req, res, myContext);
        }

        //DBڑI
        if (myContext.dbAccess){
            try{
                myContext.jdbcConnection.close();
            }catch(Exception e){
                myContext.isError = true;
            }
        }

        if (!myContext.isError){
            //펞̃tH[h̐ݒ
            //setPage()\bh́ABaseServletp
            //ۃT[ubgŒ`̂s
            setPage(myContext);
        }else{
            //G[̃tH[h̐ݒ
            //setErrorPage()\bh́ABaseServletp
            //ۃT[ubgŒ`̂s
            setErrorPage(myContext);
        }

        //tH[hs
        forward(req, res, myContext);
    }

    //Oݒ菈
    private void setup(HttpServletRequest req,
                HttpServletResponse res, Context myContext){
        try{
            // f[^x[Xڑ
            if (myContext.dbAccess){
                String url = myContext.dbUrl + "?useUnicode=true"
                        + "&characterEncoding=" + myContext.dbEncode;
                Class driverClass =
                            Class.forName(myContext.driverName);
                myContext.jdbcConnection =
                            DriverManager.getConnection(
                            url,
                            myContext.dbUserName,
                            myContext.dbPassword);
                myContext.jdbcConnection.setAutoCommit(false);
            }
            //NGXg̃GR[hݒ
            req.setCharacterEncoding(myContext.uiEncode);
        }catch(Exception e){
            myContext.isError = true;
            myContext.message = e.toString();
        }
    }

    //tH[h
    private void forward(HttpServletRequest req,
                HttpServletResponse res, Context myContext){
        ServletContext cont = getServletContext();
        RequestDispatcher rd =
                    cont.getRequestDispatcher(myContext.nextPage);
        try{
            rd.forward(req, res);
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    //ZbVݒ
    protected void setAttribute(String key, Object obj,
                HttpServletRequest req){
        req.getSession().setAttribute(key, obj);
    }
    
    //ZbV擾
    protected Object getAttribute(String key,
                HttpServletRequest req){
        return req.getSession().getAttribute(key);
    }
    
    //NGXgp[^擾
    protected String getParameter(String key,
                HttpServletRequest req){
            return req.getParameter(key);
    }
    
    //ʃf[^\̎擾
    protected Context getMyContext(String key,
                HttpServletRequest req){
        Context cont = (Context)getAttribute(key, req);
        if (cont == null){
            cont = new Context();
            cont.isError = true;
        }
        return cont;
    }

    //
    //񂪐ǂ̔(̏ꍇtrueԂ)
    protected boolean isNumber(String str){
        try{
            Integer.parseInt(str);
        }catch(Exception e){
            return false;
        }
        return true;
    }
    //

    //ۃ\bh
    //ȉ̃\bhBaseServletpۃT[ubgŎ
    protected abstract Context getContext(HttpServletRequest req);

    protected abstract void action(HttpServletRequest req,
                HttpServletResponse res, Context myContext);

    protected abstract void setPage(Context myContext);

    protected abstract void setErrorPage(Context myContext);

}